/*
 *
 *   Copyright 2009-2016 Weibo, Inc.
 *
 *     Licensed under the Apache License, Version 2.0 (the "License");
 *     you may not use this file except in compliance with the License.
 *     You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 *     Unless required by applicable law or agreed to in writing, software
 *     distributed under the License is distributed on an "AS IS" BASIS,
 *     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *     See the License for the specific language governing permissions and
 *     limitations under the License.
 *
 */

package com.weibo.api.motan.registry.weibomesh;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.serializer.SimplePropertyPreFilter;
import com.weibo.api.motan.rpc.URL;

/**
 * @author zhanglei28
 * @date 2021/8/6.
 */
public class Util {
    private static SimplePropertyPreFilter FILTER = new SimplePropertyPreFilter(URL.class, "protocol", "host", "port", "path", "parameters", "group");

    public static String UrlToJson(URL url) {
        return JSON.toJSONString(url, FILTER);
    }

    public static URL JsonToUrl(String urlString) {
        return JSON.parseObject(urlString, URL.class);
    }
}
